 /**
 * Title: Advanced01 - Examples about Hashtable and Enumeration
 * Description:
 * Copyright:    Copyright (c) 2004
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.advanced ;

import java.awt.*;
import java.util.* ;
import java.applet.*;
import java.awt.event.*;

/** Applet showing some Data Structures classes.				*/
public class Advanced01 extends Applet implements ActionListener {


	// ATTRIBUTES
	Hashtable table ;
	Label counter	= new Label("0") ;
	Button create 	= new Button("Create") ;
	Button refresh 	= new Button("Refresh") ;
	Button search 	= new Button("Search") ;
	Button count 	= new Button("Count") ;
	TextField number= new TextField("42000",6) ;
	TextField size  = new TextField("100",6) ;
	TextField load  = new TextField("0.7",6) ;
	TextField value = new TextField("1",6) ;


	/**	Run by the Browser to initialize the Applet. 				*/
    public void init()    {

		Panel p = new Panel() ;
		p.setLayout(new GridLayout(6,2,30,30)) ;
		p.add(new Label("Enter number of objects:")) ;
		p.add(number) ;
		p.add(new Label("Enter size of Hashtable:")) ;
		p.add(size) ;
		p.add(new Label("Enter Load Factor for the Hashtable:")) ;
		p.add(load) ;
		p.add(create) ;
		p.add(counter) ;
		p.add(search) ;
		p.add(value) ;
		p.add(refresh) ;
		p.add(count) ;
		setLayout(new BorderLayout()) ;
		add(p, "Center") ;
		add(new Label("       "), "North") ;
		add(new Label("       "), "East") ;
		add(new Label("       "), "West") ;
		add(new Label("       "), "South") ;

		create.addActionListener(this) ;
		refresh.addActionListener(this) ;
		search.addActionListener(this) ;
		count.addActionListener(this) ;
	 }


	/**	Run when the one of the buttons is pressed.	  */
    public void actionPerformed(ActionEvent event)    {

		// Creates the Hashtable
		if (event.getSource() == create) {

			int objects = parseInt(number.getText()) ;
			int max 	= parseInt(size.getText()) ;
			int factor  = parseInt(load.getText()) ;
			if ((factor > 0) && (factor < 1)) table = new Hashtable(max, factor);
				else table = new Hashtable(max);

			for (int i = 1; i <= objects; i++) {
				table.put(new Integer(i), this) ;
				counter.setText(i + "/" + max) ;
			}
		}

		// Refreshes the Hashtable parameters
		if (event.getSource() == refresh) {

			int objects = table.size() ;
			int max = parseInt(size.getText()) ;
			max = (objects < max)?max:objects;
			counter.setText(objects + "/" + max) ;
		}

		// Search a value in the Hashtable
		if (event.getSource() == search) {

			String string = value.getText() ;
			int lookFor = parseInt(string) ;
			Integer key = new Integer(lookFor) ;
			Applet foo = (Applet) table.get(key) ;
			if (foo != null) value.setText("Found " + lookFor) ;
				else value.setText(lookFor + " not found") ;
		}

		// Counts the elements in the Enumeration.
		// Remark: it's not possible to "rewind" an Enumeration already scrolled,
		// in order to scroll it twice, it must be re-created !!!
		if (event.getSource() == count) {

			int k = 0 ;
			int e = 0 ;
			if (table != null) {

				Enumeration keys = table.elements() ;
				Enumeration elements = table.elements() ;

				// Counting keys in the table
				while ( keys.hasMoreElements() ) {
					Applet foo = (Applet) keys.nextElement();
					if (foo != null) k++ ;
				}
				// Counting elements in the table
				while ( elements.hasMoreElements() ) {
					Applet foo = (Applet) elements.nextElement();
					if (foo != null) e++ ;
				}

			}
			if (k == e) count.setLabel("Found: " + k) ;
		}
	 }


	/**	Used to parse the integer values specified in the TextField's.	*/
    public int parseInt(String string)    {

		int result = 0 ;
		if ( (string != null) && (string.length() > 0) ) try { result = Integer.parseInt(string);	}
		catch(Exception error) { System.err.println("*Error parsing integer for value " + string);	}

		return result ;
	}


}	// End of class
