 /**
 * Title: Advanced03 - a simple parser using the StringTokenizer class
 * Description:
 * Copyright:    Copyright (c) 2004
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.advanced ;

import java.io.*;
import java.util.* ;


/** A simple parser reading text from the keyboard.	*/
public class Advanced03 {


	/** The main method launched at start-up. 		*/
	public static void main(String args[]) {

		Advanced03 application = new Advanced03() ;
		String target = application.getString() ;
		application.parse(target) ;
	}


	/** Read the string from the keyboard and return it already trimmed.	*/
	public String getString() {

		int n = 0 ;
		String value ;
		byte[] array = new byte[50] ;
		System.out.print("Please enter your phrase: ") ;

		try 					{	n = System.in.read(array) ;			}
		catch(IOException e) 	{	System.err.println("Bad Input") ;	}

		// We need to trim, otherwise the string is always 50 characters long.
		value = new String(array) ;
		value = value.trim() ;
		System.out.println("You wrote: " + value + ".\n") ;

		return value;
	}


	/** Parse the String as necessary, using '*' as delimiter.	*/
	public void parse(String string) {

		int max = 50 ;
		String token;
        Stack stack = new Stack( );

        // We include carriage return and other special characters.
        // We do not include the blank space !!!
        StringTokenizer tokenizer = new StringTokenizer(string, "*\n\t\r\f");
        System.out.println("Now parsing the string:") ;

		// First: splitting input phrase and storing elements
        while ( tokenizer.hasMoreTokens() ) {

            token = tokenizer.nextToken( );
            int n = token.length() ;
            max = (max > n)?n:max ;
            stack.push(token);
		}

		// Second: retrieving elements and cutting
		while ( ! stack.empty() ) {
			String current = (String) stack.pop();
			int size = current.length() ;
			int end = (size  < max)?size:max;
			System.out.println(current.substring(0,end)) ;
		}
	}


}	// End of class
